<?php

/*
 * @contains to: Brutal Cache
 * @version: 0.5
 * @author: Steffen Wendt
 *
 * @coment: this is put in a function for reason! the variables here needed are only local,
 *          so it will save heap
 */

/*
 * @action: this function will check wheather a cachefile exists or not. if it exists
 *          it will serve this filefor output, if not it will do nothing so WordPress
 *          could be started
 *
 * @return: void
 */

function bcp_brutal_mode() {
    define('BRUTAL_CACHE_INSIDE', 'SAW_INSIDE');

    if ( isset( $_POST['submit'] ) && !empty( $_POST['submit'] ) ) {
        return;
    }
    $BRUTAL_CACHE_DIR = str_replace( '\\', '/', dirname( __FILE__ ) );
    if ( file_exists( $BRUTAL_CACHE_DIR.'/brutal_cache_config.php' ) ) {
        include( $BRUTAL_CACHE_DIR.'/brutal_cache_config.php' );
    } else {
        return;
    }

    if ($_SERVER['REQUEST_URI'] == '/') {
        $filename = 'home';
    } else {
        $filename = str_replace('/', '.', $_SERVER['REQUEST_URI']);
    }
    
    $cache_file = $BRUTAL_CACHE_DIR.'/cache/'.$filename.'.cache';
    $cache_file_timestamp = @filemtime( $cache_file );

    if ( $bcp_config['use_user_stored'] == 1 && file_exists($cache_file) ) {
        //Cache laden wenn Files nicht Verändert
        $gmt_mtime = gmdate('r', $cache_file_timestamp);
        header('ETag: "'.md5($cache_file_timestamp.$cache_file).'"');
        if( @isset($_SERVER['HTTP_IF_MODIFIED_SINCE']) || @isset($_SERVER['HTTP_IF_NONE_MATCH']) ) {
            if ($_SERVER['HTTP_IF_MODIFIED_SINCE'] == $gmt_mtime || str_replace('"', '', stripslashes($_SERVER['HTTP_IF_NONE_MATCH'])) == md5($cache_file_timestamp.$cache_file)) {
                header('HTTP/1.1 304 Not Modified');
                exit();
            }
        }
        header( 'Last-Modified: '.$gmt_mtime );
        header( 'Cache-Control: public' );
    }
    
    if ( $bcp_config['timeval_active'] ) {
        if ( file_exists($cache_file) && ( $cache_file_timestamp + $bcp_config['timeval_time'] > time() ) ) {
            $cache = file_get_contents( $cache_file );
            if ( !empty( $cache ) ) {
                exit( $cache );
            } else {
                return;
            }
        } else {
            return;
        }
    } else {
        if ( file_exists( $cache_file ) ) {
            $cache = file_get_contents( $cache_file );
            if ( !empty( $cache ) ) {
                exit( $cache );
            } else {
                return;
            }
        } else {
            return;
        }
    }    
}

//calling the function
bcp_brutal_mode();

?>